////////////////////////////////////////////////////////////////////////////////
// File name: CommonLib.cpp
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.chat.ru/CommonLib.html
// Date: 2006 01 28
//
// Description:   
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h" //     MFC /  Precompiled Headers

//#include <time.h>
#include "CommonLib.h"
#include <AtlConv.h>

#include <WinSock.h>
#pragma comment(lib, "ws2_32")

#include <CommDlg.h>
#pragma comment(lib, "ComDlg32")

#include <CDErr.h> // Common dialog error return codes

#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
   #include <ObjBase.h> // CoInitializeEx
   #pragma comment(lib, "ole32")
#endif // DCOM

#include <WinVer.h>
#pragma comment(lib, "Version")

namespace nsWinInet_API {
   #include <WinInet.h>
}
#pragma comment(lib, "WinInet")

#ifdef __AFX_H__
   #ifdef _DEBUG
      #undef THIS_FILE
      static char THIS_FILE[]=__FILE__;
      #define new DEBUG_NEW
   #endif
#endif

void Base64_code(
   IN const CHAR* strIn, //    - ,   
   OUT CString& strOut   //   -  
) {
   const static CHAR base64ABC[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
   strOut.Empty();
   const size_t len = strlen(strIn);
   for (size_t i=0; i<len; i+=3) {
      LONG l = (                 ((LONG)strIn[i  ])<<16      ) |
               (((i+1) < len) ? (((LONG)strIn[i+1])<<8 ) : 0 ) |
               (((i+2) < len) ? ( (LONG)strIn[i+2]     ) : 0 );
                     strOut += base64ABC[(l>>18) & 0x3F];
                     strOut += base64ABC[(l>>12) & 0x3F];
      if (i+1 < len) strOut += base64ABC[(l>> 6) & 0x3F];
      if (i+2 < len) strOut += base64ABC[(l    ) & 0x3F];
   }
   switch (len%3) {
   case 1:
      strOut += '=';
   case 2:
      strOut += '=';
   }
}

void Base64_decode(
   IN const CHAR* strIn, //    -  
   OUT CString& strOut   //   -  
) {
   const static CHAR base64ABC[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
   strOut.Empty();
   const size_t len = strlen(strIn);
   for (size_t i=0; i<len; i+=4) {
      LONG l =
         ((                 (strIn[i  ] != '=')) ? (((LONG)(strchr(base64ABC, strIn[i  ]) - base64ABC)) << 18) : 0) |
         ((((i+1) < len) && (strIn[i+1] != '=')) ? (((LONG)(strchr(base64ABC, strIn[i+1]) - base64ABC)) << 12) : 0) |
         ((((i+2) < len) && (strIn[i+2] != '=')) ? (((LONG)(strchr(base64ABC, strIn[i+2]) - base64ABC)) << 6 ) : 0) |
         ((((i+3) < len) && (strIn[i+3] != '=')) ?  ((LONG)(strchr(base64ABC, strIn[i+3]) - base64ABC))        : 0);

      BYTE ch1 = ((l>>16) & 0xFF); if (ch1) strOut += (TCHAR)ch1;
      BYTE ch2 = ((l>>8 ) & 0xFF); if (ch2) strOut += (TCHAR)ch2;
      BYTE ch3 = ( l      & 0xFF); if (ch3) strOut += (TCHAR)ch3;
   }
}

BOOL Base64_code(
   IN BYTE *pData,     //    - ,   
   IN DWORD dwSize,
   OUT CString &strRes //   -  
) {
   if (!pData || !dwSize) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }

   strRes.Empty();
   const static CHAR base64ABC[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
   for (size_t i=0; i<dwSize; i+=3) {
      LONG l = (                    ((LONG)pData[i  ])<<16      ) |
               (((i+1) < dwSize) ? (((LONG)pData[i+1])<<8 ) : 0 ) |
               (((i+2) < dwSize) ? ( (LONG)pData[i+2]     ) : 0 );
                        strRes += base64ABC[(l>>18) & 0x3F];
                        strRes += base64ABC[(l>>12) & 0x3F];
      if (i+1 < dwSize) strRes += base64ABC[(l>> 6) & 0x3F];
      if (i+2 < dwSize) strRes += base64ABC[(l    ) & 0x3F];
   }
   switch (dwSize%3) {
   case 1:
      strRes += _T('=');
   case 2:
      strRes += _T('=');
   }
   return TRUE;
}

BOOL Base64_decode(
   IN const CString &strIn, //    -  
   OUT BYTE *pData,         //   -  
   IN OUT DWORD &dwSize
) {
   if (strIn.IsEmpty() || !pData || !dwSize) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }

   const static CString base64ABC = _T("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
   ZeroMemory(pData, dwSize);
   DWORD dwWrite = 0;
   for (int i=0; i<strIn.GetLength(); i+=4) {
      bool in0=true , in1=false, in2=false, in3=false; //    
      bool bE0=false, bE1=false, bE2=false, bE3=false; //    "="
      int  iF0=0    , iF1=0    , iF2=0    , iF3=0    ; //     Base64 

      LONG l = ((in0 = (i+0) < strIn.GetLength()) && (bE0 = (strIn[i+0] != _T('='))) ? LONG(iF0 = base64ABC.Find(strIn[i  ])) << 18 : 0) |
               ((in1 = (i+1) < strIn.GetLength()) && (bE1 = (strIn[i+1] != _T('='))) ? LONG(iF1 = base64ABC.Find(strIn[i+1])) << 12 : 0) |
               ((in2 = (i+2) < strIn.GetLength()) && (bE2 = (strIn[i+2] != _T('='))) ? LONG(iF2 = base64ABC.Find(strIn[i+2])) << 6  : 0) |
               ((in3 = (i+3) < strIn.GetLength()) && (bE3 = (strIn[i+3] != _T('='))) ? LONG(iF3 = base64ABC.Find(strIn[i+3])) << 0  : 0);
      if ((iF0 == -1) || (iF1 == -1) || (iF2 == -1) || (iF3 == -1)) { //    ""    Base64 ...
         ZeroMemory(pData, dwSize);
         dwSize = 0;
         ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
         return FALSE;
      }

      bool bB = true; //   
      BYTE b1 = ((l>>16) & 0xFF); if (in0 && bE0 && (b1 || bE1) && (bB &= (dwSize > dwWrite))) {pData[dwWrite++] = b1;}
      BYTE b2 = ((l>>8 ) & 0xFF); if (in1 && bE1 && (b2 || bE2) && (bB &= (dwSize > dwWrite))) {pData[dwWrite++] = b2;}
      BYTE b3 = ((l>>0 ) & 0xFF); if (in2 && bE2 && (b3 || bE3) && (bB &= (dwSize > dwWrite))) {pData[dwWrite++] = b3;}
      if (!bB) {
         ::SetLastError(ERROR_INSUFFICIENT_BUFFER);
         return FALSE;
      }
   }
   dwSize = dwWrite;
   return TRUE;
}

CString SelectFile(BOOL bOpenDialog, HWND hWndOwner, LPCTSTR szDefSelectedFile, LPCTSTR szDefExt, LPCTSTR szFilter, LPCTSTR szTitle, LPCTSTR szInitialDir, DWORD dwFlags) {
   CString strFileName;
   DWORD nMaxFile = max(MAX_PATH, (szDefSelectedFile ? lstrlen(szDefSelectedFile)+1 : 0));
anew1:
   TCHAR *szFile = new TCHAR [nMaxFile];
anew2:
   if (szFile == NULL) {
      ::SetLastError(ERROR_OUTOFMEMORY);
   } else {
      szFile[0] = 0;
      if (szDefSelectedFile) {
         lstrcpyn(szFile, szDefSelectedFile, min(nMaxFile, (DWORD)lstrlen(szDefSelectedFile)+1));
      }
      OPENFILENAME OpenFileName = {
         sizeof(OPENFILENAME)    , // DWORD         lStructSize;
         hWndOwner               , // HWND          hwndOwner;
         NULL                    , // HINSTANCE     hInstance;
         szFilter                , // LPCTSTR       lpstrFilter;
         NULL                    , // LPTSTR        lpstrCustomFilter;
         0                       , // DWORD         nMaxCustFilter;
         0                       , // DWORD         nFilterIndex;
         szFile                  , // LPTSTR        lpstrFile;
         nMaxFile                , // DWORD         nMaxFile;
         NULL                    , // LPTSTR        lpstrFileTitle;
         0                       , // DWORD         nMaxFileTitle;
         szInitialDir            , // LPCTSTR       lpstrInitialDir;
         szTitle                 , // LPCTSTR       lpstrTitle;
         dwFlags                 , // DWORD         Flags;
         0                       , // WORD          nFileOffset;
         0                       , // WORD          nFileExtension;
         szDefExt                , // LPCTSTR       lpstrDefExt;
         0                       , // LPARAM        lCustData;
         NULL                    , // LPOFNHOOKPROC lpfnHook;
         NULL                      // LPCTSTR       lpTemplateName;
      };
      if (bOpenDialog ? ::GetOpenFileName(&OpenFileName) : ::GetSaveFileName(&OpenFileName)) {
         strFileName = szFile;
      } else {
         DWORD dwError = ::CommDlgExtendedError();
         switch (dwError) {
         case FNERR_BUFFERTOOSMALL:
            {
               delete [] szFile; szFile = NULL;
               nMaxFile = nMaxFile << 4;
               goto anew1;
            } break;
         case FNERR_INVALIDFILENAME:
            {
               szDefSelectedFile = NULL;
               goto anew2;
            } break;
         }
      }
      delete [] szFile; szFile = NULL;
   }
   return strFileName;
}

CString SelectFolder(
   HWND hWndOwner,   //    
   LPCTSTR szTitle,
   DWORD dwFlags,
   int nFolder)      //  -1 -      
                     //  CSIDL_... ( , see SHGetSpecialFolderLocation) -   
{
   CString strFolder;
   IMalloc *pMalloc = NULL;
#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
   HRESULT hRes = ::CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
#endif // DCOM
   if (::SHGetMalloc(&pMalloc) == NOERROR) {
      ITEMIDLIST *pIIdL = NULL;
      TCHAR szFolder[MAX_PATH] = {0};
      if (nFolder == -1) {
         BROWSEINFO bi = {
            hWndOwner      , // HWND            hwndOwner;
            NULL           , // LPCITEMIDLIST   pidlRoot;
            szFolder       , // LPTSTR          pszDisplayName;
            szTitle        , // LPCTSTR         lpszTitle;
            dwFlags        , // UINT            ulFlags;
            NULL           , // BFFCALLBACK     lpfn;
            0              , // LPARAM          lParam;
            0                // int             iImage;
         };
         ITEMIDLIST *pIIdL = ::SHBrowseForFolder(&bi);
         if (pIIdL != NULL) {
            strFolder = szFolder; //   
            if (::SHGetPathFromIDList(pIIdL, szFolder)) {
               strFolder = szFolder; //  
            }
         }
      } else {
         if (::SHGetSpecialFolderLocation(hWndOwner, nFolder, &pIIdL) == NOERROR) {
            if (::SHGetPathFromIDList(pIIdL, szFolder)) {
               strFolder = szFolder; //  
            }
         }
      }
      if (pIIdL) {
         pMalloc->Free(pIIdL); pIIdL = NULL;
      }
      pMalloc->Release(); pMalloc = NULL;
   }
   return strFolder;
}

//  
LONGLONG GetFileSizeEx(LPCTSTR szFileName) {
   LONGLONG llSize = INVALID_FILE_SIZE;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (FileExist(szFileName)) {
      HANDLE hFile = ::CreateFile(
         szFileName,
         GENERIC_READ,
         FILE_SHARE_READ,
         NULL,
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL,
         NULL
      );
      if (hFile == INVALID_HANDLE_VALUE) {
         dwErrCode = ::GetLastError();
      } else {
         DWORD dwSizeHigh = 0;
         DWORD dwSizeLow  = ::GetFileSize(hFile, &dwSizeHigh);
         dwErrCode = ::GetLastError();
         if ((dwSizeLow == INVALID_FILE_SIZE) &&
             (dwErrCode != NO_ERROR))
         {
            // error!
         } else {
            dwErrCode = ERROR_SUCCESS;
            llSize = MAKELONGLONG(dwSizeLow, dwSizeHigh);
         }
         ::CloseHandle(hFile); hFile = NULL;
      }
   } else {
      dwErrCode = ERROR_FILE_NOT_FOUND;
   }
   ::SetLastError(dwErrCode);
   return llSize;
}

//  
DWORD GetFileSize(LPCTSTR szFileName) {
   DWORD dwSize = INVALID_FILE_SIZE;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (FileExist(szFileName)) {
      HANDLE hFile = ::CreateFile(
         szFileName,
         GENERIC_READ,
         FILE_SHARE_READ,
         NULL,
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL,
         NULL
      );
      if (hFile == INVALID_HANDLE_VALUE) {
         dwErrCode = ::GetLastError();
      } else {
         dwSize = ::GetFileSize(hFile, NULL);
         if (dwSize == INVALID_FILE_SIZE) {
            dwErrCode = ::GetLastError();
         }
         ::CloseHandle(hFile); hFile = NULL;
      }
   } else {
      dwErrCode = ERROR_FILE_NOT_FOUND;
   }
   ::SetLastError(dwErrCode);
   return dwSize;
}

CString GetFileVersion(LPCTSTR szFilename) {
   CString strRes;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!FileExist(szFilename)) {
      dwErrCode = ::GetLastError();
   } else {
      DWORD dwSize = ::GetFileVersionInfoSize(szFilename, 0);
      if (dwSize == 0) {
         dwErrCode = ::GetLastError();
      } else {
         BYTE *pData = new BYTE [dwSize];
         if (pData == NULL) {
            dwErrCode = ERROR_OUTOFMEMORY;
         } else {
            BOOL bRes = ::GetFileVersionInfo(szFilename, 0, dwSize, pData);
            if (!bRes ) {
               dwErrCode = ::GetLastError();
            } else {
               VS_FIXEDFILEINFO *pFixeFileInfo = NULL;
               UINT uLen = 0;
               bRes = ::VerQueryValue(pData, _T("\\"), (void**)&pFixeFileInfo, &uLen);
               if (!bRes) {
                  dwErrCode = ::GetLastError();
               } else {
                  int v1 = HIWORD(pFixeFileInfo->dwFileVersionMS);
                  int v2 = LOWORD(pFixeFileInfo->dwFileVersionMS);
                  int v3 = HIWORD(pFixeFileInfo->dwFileVersionLS);
                  int v4 = LOWORD(pFixeFileInfo->dwFileVersionLS);
                  strRes.Format(_T("%i.%i.%i.%i"), v1,v2,v3,v4);
               }
            }
            delete [] pData; pData = NULL;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return strRes;
}

CString GetWindowText(HWND hWnd) {
   CString strCaption;
   int iBuff = 32;
   TCHAR *szCaption = NULL;
   int iRes = 0;
   DWORD dwErrCode = ERROR_SUCCESS;
   do {
      szCaption = new TCHAR[iBuff = iBuff<<1];
      if (szCaption == NULL) {
         dwErrCode = ERROR_OUTOFMEMORY;
         break;
      } else {
         szCaption[0] = 0;
         ::SetLastError(ERROR_SUCCESS);
         iRes = ::GetWindowText(hWnd, szCaption, iBuff);
         dwErrCode = ::GetLastError();
         BOOL bBreak = FALSE;
         if ((iRes==0) || (iRes < (iBuff-1))) {
            strCaption = szCaption;
            bBreak = TRUE;
         }
         delete [] szCaption; szCaption = NULL;
         if (bBreak) break;
      }
   } while(true);
   ::SetLastError(dwErrCode);
   return strCaption;
}

HBITMAP CreateMask(HBITMAP hBmp, COLORREF transparentColor) {
   BITMAP bmp; memset(&bmp, 0, sizeof(BITMAP));
   ::GetObject(hBmp, sizeof(BITMAP), &bmp);
   HBITMAP hBmpMask = ::CreateMask(SIZEEX(bmp.bmWidth, bmp.bmHeight));

   HDC hDC_Dst = ::CreateCompatibleDC(NULL);
   HDC hDC_Src = ::CreateCompatibleDC(NULL);
   HBITMAP hBmpSaveSrc = (HBITMAP)::SelectObject(hDC_Src, hBmp);
   HBITMAP hBmpSaveDst = (HBITMAP)::SelectObject(hDC_Dst, hBmpMask);

   COLORREF oldBkColor = ::SetBkColor(hDC_Src, (transparentColor == CLR_INVALID) ? GetPixel(hDC_Src, 0, 0) : transparentColor);
   ::BitBlt(hDC_Dst, 0,0, bmp.bmWidth, bmp.bmHeight, hDC_Src, 0, 0, NOTSRCCOPY);
   ::SetBkColor(hDC_Src, oldBkColor);

   ::SelectObject(hDC_Dst, hBmpSaveDst);
   ::SelectObject(hDC_Src, hBmpSaveSrc);
   ::DeleteDC(hDC_Dst);
   ::DeleteDC(hDC_Src);

   return hBmpMask;
}

CString MemCopyAsString(LPCVOID pData, size_t iSize, TCHAR chSeparatorEOL) {
   CString strData;
   if (pData && iSize) {
      size_t newSize = iSize+sizeof(TCHAR); // + EOL
      if (sizeof(TCHAR) == sizeof(WCHAR)) {
         if (newSize&1) {
            newSize += 1; //     
         }
      }
      TCHAR *szData = (TCHAR*) new BYTE[newSize];
      size_t sizeLen = newSize/sizeof(TCHAR)-1;
      if (sizeLen>0) szData[sizeLen-1] = _T('\0'); // ,   
      szData[sizeLen] = _T('\0'); // EOL
      memcpy(szData, pData, iSize);
      if (chSeparatorEOL) {
         for (size_t i=0; i<sizeLen; i++) {
            TCHAR *pCh = &szData[i];
            if (!*pCh) {
               *pCh = chSeparatorEOL;
            }
         }
      }
      strData = szData;
      delete [] (BYTE*)szData;
   }
   return strData;
}

CString MemCopyAsHex(LPCVOID pData, size_t iSize, BOOL bUsePrefix, LPCTSTR szSeparator)
{
   /*
   //      
   CString strRes;
   for (size_t i=0; i<iSize; i++) {
      if (szSeparator && szSeparator[0]) {
         strRes += szSeparator;
      }
      strRes += ::Format(bUsePrefix ? _T("0x%02X") : _T("%02X"), int(((BYTE*)pData)[i]));
   }
   if (!strRes.IsEmpty() && szSeparator && szSeparator[0]) {
      strRes = strRes.Mid(lstrlen(szSeparator));
   }
   /**/
   int iMaxCharIndex = (iSize<<1) + (bUsePrefix ? (iSize<<1) : 0) + ((szSeparator && szSeparator[0])?(lstrlen(szSeparator)*(iSize-1)):0);
   CString strRes(_T('\0'), iMaxCharIndex+1);
   int j=0;
   for (size_t i=0; i<iSize; i++) {
      if (bUsePrefix) {
         strRes.SetAt(j++, _T('0'));
         strRes.SetAt(j++, _T('x'));
      }

      BYTE bH = ((BYTE*)pData)[i] >> 4;
      BYTE bL = ((BYTE*)pData)[i] & 0x0F;

      TCHAR ch = (bH < 10) ? (_T('0')+bH) : (_T('A')+(bH-10));
      strRes.SetAt(j++, ch);

      ch = (bL < 10) ? (_T('0')+bL) : (_T('A')+(bL-10));
      strRes.SetAt(j++, ch);

      if ((i<iSize-1) && szSeparator && szSeparator[0]) {
         for (int k=0; *(szSeparator+k); k++) {
            strRes.SetAt(j++, szSeparator[k]);
         }
      }
   }
   return strRes;
}


void BeepSpeaker(DWORD dwFreq, DWORD dwDuration)
{
   dwFreq = min(max(0x25, dwFreq), 0x7FFF);
   static OSVERSIONINFO OsVersion = {
      sizeof(OSVERSIONINFO), // DWORD dwOSVersionInfoSize;
      0,                     // DWORD dwMajorVersion;
      0,                     // DWORD dwMinorVersion;
      0,                     // DWORD dwBuildNumber;
      0,                     // DWORD dwPlatformId;
      {_T('\0'),}            // TCHAR szCSDVersion[128];
   };
   static BOOL bRes = ::GetVersionEx(&OsVersion);

   /* We need to check if we're running on NT, because NT
   does not allow the "out" assembler command for security
   reasons and the Beep API function works via the speaker on NT,
   so that's ok.
   On Windows 9x Beep will sound the default system
   beep which is in most cases through the soundblaster.
   (frequency is not supported under Windows 9x) */

   if (OsVersion.dwPlatformId == VER_PLATFORM_WIN32_NT) {
      ::Beep(dwFreq, dwDuration);
   } else { //VER_PLATFORM_WIN32_WINDOWS
      __asm
      {
         mov al, -1
         out 61h, al
      }
      Sleep(dwDuration);
      __asm
      {
         mov al, 0
         out 61h, al
      }
   }
}

//      
/* static */ CString CRegistry::GetString(IN HKEY hKey, IN LPCTSTR szName, OUT PDWORD pdwErrCode) {
   CString strResult;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!hKey || !szName) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      int i=0;
      while (TRUE) {
         TCHAR szValueName[1024] = {0};
         DWORD dwSizeValueName=1024,
               dwType,
               dwSizeData=1024;
         BYTE pbData[1024] = {0};

         dwErrCode = ::RegEnumValue(hKey, i++, szValueName, &dwSizeValueName, NULL, &dwType, pbData, &dwSizeData);

         if (dwErrCode == ERROR_SUCCESS) {
            if ((dwType == REG_SZ) && (lstrcmpi(szName, szValueName) == 0)) {
               strResult = (LPCTSTR)pbData;
               break;
            }
         } else {
            break;
         }
      }
   }
   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return strResult;
}

//      
/* static */ DWORD CRegistry::GetDWord(IN HKEY hKey, IN LPCTSTR szName, OUT PDWORD pdwErrCode) {
   DWORD dwResult = 0;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!hKey || !szName) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      int i=0;
      while (TRUE) {
         TCHAR szValueName[1024] = {0};
         DWORD dwSizeValueName=1024,
               dwType,
               dwSizeData=1024;
         BYTE pbData[1024] = {0};

         dwErrCode = ::RegEnumValue(hKey, i++, szValueName, &dwSizeValueName, NULL, &dwType, pbData, &dwSizeData);

         if (dwErrCode == ERROR_SUCCESS) {
            if ((dwType == REG_DWORD) && (lstrcmpi(szName, szValueName) == 0)) {
               dwResult = *((int*)pbData);
               break;
            }
         } else {
            break;
         }
      }
   }
   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return dwResult;
}

//      
/* static */ DWORD CRegistry::GetBinary(IN HKEY hKey, IN LPCTSTR szName, OUT BYTE *pbValue, IN OUT DWORD &dwSizeValue) {
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!hKey || !szName || !pbValue || !dwSizeValue) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      int i=0;
      while (TRUE) {
         TCHAR szValueName[1024] = {0};
         DWORD dwSizeValueName=1024,
               dwType,
               dwSizeData=1024;
         BYTE pbData[1024] = {0};

         dwErrCode = ::RegEnumValue(hKey, i++, szValueName, &dwSizeValueName, NULL, &dwType, pbData, &dwSizeData);

         if (dwErrCode == ERROR_SUCCESS) {
            if ((dwType == REG_BINARY) && (lstrcmpi(szName, szValueName) == 0)) {
               if(dwSizeValue >= dwSizeData) {
                  dwSizeValue  = dwSizeData;
                  memcpy(pbValue, pbData, dwSizeValue);
               } else {
                  dwErrCode = ERROR_INSUFFICIENT_BUFFER;
               }
               break;
            }
         } else {
            break;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return dwErrCode;
}

//       
/* static */ DWORD CRegistry::SetString(IN HKEY hKey, IN LPCTSTR szName, IN LPCTSTR szValue) {
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!hKey || !szName) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      dwErrCode = ::RegSetValueEx(hKey, szName, 0, REG_SZ, (LPBYTE)szValue, (lstrlen(szValue)+1)<<(sizeof(TCHAR)-1));
   }
   return dwErrCode;
}

//       
/* static */ DWORD CRegistry::SetDWord(IN HKEY hKey, IN LPCTSTR szName, IN DWORD dwValue) {
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!hKey || !szName) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      dwErrCode = ::RegSetValueEx(hKey, szName, 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));
   }
   return dwErrCode;
}

//       
/* static */ DWORD CRegistry::SetBinary(IN HKEY hKey, IN LPCTSTR szName, IN const BYTE *pbValue, IN DWORD dwSizeValue) {
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!hKey || !szName || !pbValue || !dwSizeValue) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      dwErrCode = ::RegSetValueEx(hKey, szName, 0, REG_BINARY, pbValue, dwSizeValue);
   }
   return dwErrCode;
}

/* static */ CString CRegistry::GetString(IN LPCTSTR szKeyName, OUT PDWORD pdwErrCode) {
   DWORD dwErrCode = ERROR_SUCCESS;
   CString strResult;

   CString strKeyName(szKeyName);
   strKeyName.TrimLeft(_T('\\'));

   HKEY hKey = NULL;

   do {
      int iPos = strKeyName.Find(_T('\\'));
      if (iPos != -1) {
         CString strKey = strKeyName.Left(iPos);
         if (hKey == NULL) {
            if (strKey.CompareNoCase(_T("HKEY_CLASSES_ROOT"  )) == 0) hKey = HKEY_CLASSES_ROOT  ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_USER"  )) == 0) hKey = HKEY_CURRENT_USER  ; else
            if (strKey.CompareNoCase(_T("HKEY_LOCAL_MACHINE" )) == 0) hKey = HKEY_LOCAL_MACHINE ; else
            if (strKey.CompareNoCase(_T("HKEY_USERS"         )) == 0) hKey = HKEY_USERS         ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_CONFIG")) == 0) hKey = HKEY_CURRENT_CONFIG; else {
               dwErrCode = ERROR_PATH_NOT_FOUND;
               break;
            }
         } else {
            HKEY hKeyOld = hKey;
            dwErrCode = ::RegOpenKeyEx(hKey, strKey, 0, KEY_READ, &hKey);
            ::RegCloseKey(hKeyOld);
            if (dwErrCode != ERROR_SUCCESS) {
               break;
            }
         }
         strKeyName = strKeyName.Mid(iPos+1);
      } else {
         strResult = CRegistry::GetString(hKey, strKeyName, pdwErrCode);
         if (pdwErrCode) {
            dwErrCode = *pdwErrCode;
         } else {
            dwErrCode = ::GetLastError();
         }
         break;
      }
   } while (TRUE);
   ::RegCloseKey(hKey);

   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return strResult;
}

/* static */ DWORD CRegistry::GetDWord(IN LPCTSTR szKeyName, OUT PDWORD pdwErrCode) {
   DWORD dwErrCode = ERROR_SUCCESS;
   DWORD dwResult = 0;

   CString strKeyName(szKeyName);
   strKeyName.TrimLeft(_T('\\'));

   HKEY hKey = NULL;

   do {
      int iPos = strKeyName.Find(_T('\\'));
      if (iPos != -1) {
         CString strKey = strKeyName.Left(iPos);
         if (hKey == NULL) {
            if (strKey.CompareNoCase(_T("HKEY_CLASSES_ROOT"  )) == 0) hKey = HKEY_CLASSES_ROOT  ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_USER"  )) == 0) hKey = HKEY_CURRENT_USER  ; else
            if (strKey.CompareNoCase(_T("HKEY_LOCAL_MACHINE" )) == 0) hKey = HKEY_LOCAL_MACHINE ; else
            if (strKey.CompareNoCase(_T("HKEY_USERS"         )) == 0) hKey = HKEY_USERS         ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_CONFIG")) == 0) hKey = HKEY_CURRENT_CONFIG; else {
               dwErrCode = ERROR_PATH_NOT_FOUND;
               break;
            }
         } else {
            HKEY hKeyOld = hKey;
            dwErrCode = ::RegOpenKeyEx(hKey, strKey, 0, KEY_READ, &hKey);
            ::RegCloseKey(hKeyOld);
            if (dwErrCode != ERROR_SUCCESS) {
               break;
            }
         }
         strKeyName = strKeyName.Mid(iPos+1);
      } else {
         dwResult = CRegistry::GetDWord(hKey, strKeyName, pdwErrCode);
         if (pdwErrCode) {
            dwErrCode = *pdwErrCode;
         } else {
            dwErrCode = ::GetLastError();
         }
         break;
      }
   } while (TRUE);
   ::RegCloseKey(hKey);

   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return dwResult;
}

/* static */ DWORD CRegistry::GetBinary(IN LPCTSTR szKeyName, OUT BYTE *pbValue, IN OUT DWORD &dwSizeValue) {
   DWORD dwErrCode = ERROR_SUCCESS;

   CString strKeyName(szKeyName);
   strKeyName.TrimLeft(_T('\\'));

   HKEY hKey = NULL;

   do {
      int iPos = strKeyName.Find(_T('\\'));
      if (iPos != -1) {
         CString strKey = strKeyName.Left(iPos);
         if (hKey == NULL) {
            if (strKey.CompareNoCase(_T("HKEY_CLASSES_ROOT"  )) == 0) hKey = HKEY_CLASSES_ROOT  ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_USER"  )) == 0) hKey = HKEY_CURRENT_USER  ; else
            if (strKey.CompareNoCase(_T("HKEY_LOCAL_MACHINE" )) == 0) hKey = HKEY_LOCAL_MACHINE ; else
            if (strKey.CompareNoCase(_T("HKEY_USERS"         )) == 0) hKey = HKEY_USERS         ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_CONFIG")) == 0) hKey = HKEY_CURRENT_CONFIG; else {
               dwErrCode = ERROR_PATH_NOT_FOUND;
               break;
            }
         } else {
            HKEY hKeyOld = hKey;
            dwErrCode = ::RegOpenKeyEx(hKey, strKey, 0, KEY_READ, &hKey);
            ::RegCloseKey(hKeyOld);
            if (dwErrCode != ERROR_SUCCESS) {
               break;
            }
         }
         strKeyName = strKeyName.Mid(iPos+1);
      } else {
         dwErrCode = CRegistry::GetBinary(hKey, strKeyName, pbValue, dwSizeValue);
         break;
      }
   } while (TRUE);
   ::RegCloseKey(hKey);

   ::SetLastError(dwErrCode);
   return dwErrCode;
}

/* static */ DWORD CRegistry::SetString(IN LPCTSTR szKeyName, IN LPCTSTR szValue) {
   DWORD dwErrCode = ERROR_SUCCESS;

   CString strKeyName(szKeyName);
   strKeyName.TrimLeft(_T('\\'));

   HKEY hKey = NULL;

   do {
      int iPos = strKeyName.Find(_T('\\'));
      if (iPos != -1) {
         CString strKey = strKeyName.Left(iPos);
         if (hKey == NULL) {
            if (strKey.CompareNoCase(_T("HKEY_CLASSES_ROOT"  )) == 0) hKey = HKEY_CLASSES_ROOT  ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_USER"  )) == 0) hKey = HKEY_CURRENT_USER  ; else
            if (strKey.CompareNoCase(_T("HKEY_LOCAL_MACHINE" )) == 0) hKey = HKEY_LOCAL_MACHINE ; else
            if (strKey.CompareNoCase(_T("HKEY_USERS"         )) == 0) hKey = HKEY_USERS         ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_CONFIG")) == 0) hKey = HKEY_CURRENT_CONFIG; else {
               dwErrCode = ERROR_BAD_PATHNAME;
               break;
            }
         } else {
            HKEY hKeyOld = hKey;
            dwErrCode = ::RegCreateKey(hKey, strKey, &hKey);
            ::RegCloseKey(hKeyOld);
            if (dwErrCode != ERROR_SUCCESS) {
               break;
            }
         }
         strKeyName = strKeyName.Mid(iPos+1);
      } else {
         dwErrCode = CRegistry::SetString(hKey, strKeyName, szValue);
         break;
      }
   } while (TRUE);
   ::RegCloseKey(hKey);
   return dwErrCode;
}

/* static */ DWORD CRegistry::SetDWord(IN LPCTSTR szKeyName, IN DWORD dwValue) {
   DWORD dwErrCode = ERROR_SUCCESS;

   CString strKeyName(szKeyName);
   strKeyName.TrimLeft(_T('\\'));

   HKEY hKey = NULL;

   do {
      int iPos = strKeyName.Find(_T('\\'));
      if (iPos != -1) {
         CString strKey = strKeyName.Left(iPos);
         if (hKey == NULL) {
            if (strKey.CompareNoCase(_T("HKEY_CLASSES_ROOT"  )) == 0) hKey = HKEY_CLASSES_ROOT  ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_USER"  )) == 0) hKey = HKEY_CURRENT_USER  ; else
            if (strKey.CompareNoCase(_T("HKEY_LOCAL_MACHINE" )) == 0) hKey = HKEY_LOCAL_MACHINE ; else
            if (strKey.CompareNoCase(_T("HKEY_USERS"         )) == 0) hKey = HKEY_USERS         ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_CONFIG")) == 0) hKey = HKEY_CURRENT_CONFIG; else {
               dwErrCode = ERROR_BAD_PATHNAME;
               break;
            }
         } else {
            HKEY hKeyOld = hKey;
            dwErrCode = ::RegCreateKey(hKey, strKey, &hKey);
            ::RegCloseKey(hKeyOld);
            if (dwErrCode != ERROR_SUCCESS) {
               break;
            }
         }
         strKeyName = strKeyName.Mid(iPos+1);
      } else {
         dwErrCode = CRegistry::SetDWord(hKey, strKeyName, dwValue);
         break;
      }
   } while (TRUE);
   ::RegCloseKey(hKey);
   return dwErrCode;
}

/* static */ DWORD CRegistry::SetBinary(IN LPCTSTR szKeyName, IN const BYTE *pbValue, IN DWORD dwSizeValue) {
   DWORD dwErrCode = ERROR_SUCCESS;
   //CString strResult;

   CString strKeyName(szKeyName);
   strKeyName.TrimLeft(_T('\\'));

   HKEY hKey = NULL;

   do {
      int iPos = strKeyName.Find(_T('\\'));
      if (iPos != -1) {
         CString strKey = strKeyName.Left(iPos);
         if (hKey == NULL) {
            if (strKey.CompareNoCase(_T("HKEY_CLASSES_ROOT"  )) == 0) hKey = HKEY_CLASSES_ROOT  ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_USER"  )) == 0) hKey = HKEY_CURRENT_USER  ; else
            if (strKey.CompareNoCase(_T("HKEY_LOCAL_MACHINE" )) == 0) hKey = HKEY_LOCAL_MACHINE ; else
            if (strKey.CompareNoCase(_T("HKEY_USERS"         )) == 0) hKey = HKEY_USERS         ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_CONFIG")) == 0) hKey = HKEY_CURRENT_CONFIG; else {
               dwErrCode = ERROR_BAD_PATHNAME;
               break;
            }
         } else {
            HKEY hKeyOld = hKey;
            dwErrCode = ::RegCreateKey(hKey, strKey, &hKey);
            ::RegCloseKey(hKeyOld);
            if (dwErrCode != ERROR_SUCCESS) {
               break;
            }
         }
         strKeyName = strKeyName.Mid(iPos+1);
      } else {
         dwErrCode = CRegistry::SetBinary(hKey, strKeyName, pbValue, dwSizeValue);
         break;
      }
   } while (TRUE);
   ::RegCloseKey(hKey);
   return dwErrCode;
}

// find methods
/* static */ CString CRegistry::EnumSubKeyName(IN HKEY hKey, IN int iIndex, OUT PDWORD pdwErrCode) {
   CString strResult;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!hKey || (iIndex<0)) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      TCHAR szKeyName[1024] = {0};
      DWORD dwSizeKeyName=1024;
      PFILETIME pFileTime = NULL;

      dwErrCode = ::RegEnumKeyEx(hKey, iIndex, szKeyName, &dwSizeKeyName, NULL, NULL, NULL, pFileTime);

      if (dwErrCode == ERROR_SUCCESS) {
         strResult = szKeyName;
      }
   }

   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return strResult;
}

// find methods
/* static */ CString CRegistry::EnumSubKeyName(IN LPCTSTR szKeyName, IN int iIndex, OUT PDWORD pdwErrCode) {
   DWORD dwErrCode = ERROR_SUCCESS;
   CString strResult;

   CString strKeyName(szKeyName);
   strKeyName.TrimLeft(_T('\\'));
   strKeyName += _T('\\');

   HKEY hKey = NULL;

   do {
      int iPos = strKeyName.Find(_T('\\'));
      if (iPos != -1) {
         CString strKey = strKeyName.Left(iPos);
         if (hKey == NULL) {
            if (strKey.CompareNoCase(_T("HKEY_CLASSES_ROOT"  )) == 0) hKey = HKEY_CLASSES_ROOT  ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_USER"  )) == 0) hKey = HKEY_CURRENT_USER  ; else
            if (strKey.CompareNoCase(_T("HKEY_LOCAL_MACHINE" )) == 0) hKey = HKEY_LOCAL_MACHINE ; else
            if (strKey.CompareNoCase(_T("HKEY_USERS"         )) == 0) hKey = HKEY_USERS         ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_CONFIG")) == 0) hKey = HKEY_CURRENT_CONFIG; else {
               dwErrCode = ERROR_PATH_NOT_FOUND;
               break;
            }
         } else {
            HKEY hKeyOld = hKey;
            dwErrCode = ::RegOpenKeyEx(hKey, strKey, 0, KEY_READ | KEY_ENUMERATE_SUB_KEYS, &hKey);
            ::RegCloseKey(hKeyOld);
            if (dwErrCode != ERROR_SUCCESS) {
               break;
            }
         }
         strKeyName = strKeyName.Mid(iPos+1);
      } else {
         strResult = CRegistry::EnumSubKeyName(hKey, iIndex, pdwErrCode);
         if (pdwErrCode) {
            dwErrCode = *pdwErrCode;
         } else {
            dwErrCode = ::GetLastError();
         }
         break;
      }
   } while (TRUE);
   ::RegCloseKey(hKey);

   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return strResult;
}

/* static */ CString CRegistry::EnumValueName(IN HKEY hKey, IN int iIndex, OUT DWORD &dwType, OUT PDWORD pdwErrCode) {
   CString strResult;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!hKey || (iIndex<0)) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      TCHAR szValueName[1024] = {0};
      DWORD dwSizeValueName=1024,
            dwSizeData=1024;
      BYTE pbData[1024] = {0};

      dwErrCode = ::RegEnumValue(hKey, iIndex, szValueName, &dwSizeValueName, NULL, &dwType, pbData, &dwSizeData);

      if (dwErrCode == ERROR_SUCCESS) {
         strResult = szValueName;
      }
   }
   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return strResult;
}

/* static */ CString CRegistry::EnumValueName(IN LPCTSTR szKeyName, IN int iIndex, OUT DWORD &dwType, OUT PDWORD pdwErrCode) {
   DWORD dwErrCode = ERROR_SUCCESS;
   CString strResult;

   CString strKeyName(szKeyName);
   strKeyName.TrimLeft(_T('\\'));
   strKeyName += _T('\\');

   HKEY hKey = NULL;

   do {
      int iPos = strKeyName.Find(_T('\\'));
      if (iPos != -1) {
         CString strKey = strKeyName.Left(iPos);
         if (hKey == NULL) {
            if (strKey.CompareNoCase(_T("HKEY_CLASSES_ROOT"  )) == 0) hKey = HKEY_CLASSES_ROOT  ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_USER"  )) == 0) hKey = HKEY_CURRENT_USER  ; else
            if (strKey.CompareNoCase(_T("HKEY_LOCAL_MACHINE" )) == 0) hKey = HKEY_LOCAL_MACHINE ; else
            if (strKey.CompareNoCase(_T("HKEY_USERS"         )) == 0) hKey = HKEY_USERS         ; else
            if (strKey.CompareNoCase(_T("HKEY_CURRENT_CONFIG")) == 0) hKey = HKEY_CURRENT_CONFIG; else {
               dwErrCode = ERROR_PATH_NOT_FOUND;
               break;
            }
         } else {
            HKEY hKeyOld = hKey;
            dwErrCode = ::RegOpenKeyEx(hKey, strKey, 0, KEY_READ, &hKey);
            ::RegCloseKey(hKeyOld);
            if (dwErrCode != ERROR_SUCCESS) {
               break;
            }
         }
         strKeyName = strKeyName.Mid(iPos+1);
      } else {
         strResult = CRegistry::EnumValueName(hKey, iIndex, dwType, pdwErrCode);
         if (pdwErrCode) {
            dwErrCode = *pdwErrCode;
         } else {
            dwErrCode = ::GetLastError();
         }
         break;
      }
   } while (TRUE);
   ::RegCloseKey(hKey);

   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return strResult;
}

CString GetIPAdress() {
   HOSTENT *he = NULL;
   BYTE *IP = NULL;
   char name[0xFF];

   gethostname(name, sizeof(name));
   he = gethostbyname(name);
   if(he) {
      IP = (BYTE *)he->h_addr_list[0];
   }
   if (IP)
      return ::Format(_T("%i.%i.%i.%i"), int(IP[0]), int(IP[1]), int(IP[2]), int(IP[3]));
   else
      return CString();
}

CString GetHostName() {
   HOSTENT *he = NULL;
   BYTE *IP = NULL;
   char name[0xFF];

   gethostname(name, sizeof(name));
   he = gethostbyname(name);
   if(he)
      return CString(he->h_name);
   else
      return CString();
}

//     
LPVOID GetResource(
   IN HINSTANCE hInstance,
   IN LPCTSTR szResourceName,
   IN LPCTSTR szResourceType,
   OUT DWORD &dwSize,
   OUT PDWORD pdwErrCode
) {
   dwSize = 0;
   DWORD dwErrCode = ERROR_SUCCESS;
   LPVOID pRes = NULL;
   HRSRC hRsrc = ::FindResource(hInstance, szResourceName, szResourceType);
   if (!hRsrc) {
      dwErrCode = ::GetLastError();
   } else {
      HGLOBAL hGlobal = ::LoadResource(hInstance, hRsrc);
      if (!hGlobal) {
         dwErrCode = ::GetLastError();
      } else {
         dwSize = ::SizeofResource(hInstance, hRsrc);
         pRes = ::LockResource(hGlobal);
         if (!pRes) {
            dwErrCode = ::GetLastError();
            dwSize = 0;
         }
      }
   }
   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return pRes;
}

//              bReplaceFile == TRUE
BOOL SaveResourceAsFile(
   IN HINSTANCE hInstance,
   IN LPCTSTR szFileName,
   IN LPCTSTR szResourceName,
   IN LPCTSTR szResourceType,
   IN BOOL    bReplaceFile,
   OUT PDWORD pdwErrCode
) {
   DWORD dwErrCode = ERROR_SUCCESS;
   BOOL bRes = FALSE;
   DWORD dwSize = 0;
   BYTE *pResource = (BYTE*)GetResource(hInstance, szResourceName, szResourceType, dwSize, &dwErrCode);
   if (pResource && (dwErrCode == ERROR_SUCCESS)) {
      if (!::FileExist(szFileName)) {
         bReplaceFile = TRUE;
      }
      if (!bReplaceFile) {
         bRes = TRUE;
      } else {
         HANDLE hFile = ::CreateFile(
            szFileName,
            GENERIC_WRITE,
            FILE_SHARE_READ,
            NULL,
            CREATE_ALWAYS,
            FILE_ATTRIBUTE_NORMAL,
            NULL
         );
         if (hFile == INVALID_HANDLE_VALUE) {
            dwErrCode = ::GetLastError();
         } else {
            bRes = TRUE;
            DWORD dwNOBW = 0;
            if (szResourceType == RT_BITMAP) {
               BITMAPFILEHEADER bfh = {0x4D42, dwSize+sizeof(BITMAPFILEHEADER), 0,0, sizeof(BITMAPFILEHEADER)+*((DWORD*)pResource)};
               if (!::WriteFile(hFile, &bfh, sizeof(BITMAPFILEHEADER), &dwNOBW, NULL) || (sizeof(BITMAPFILEHEADER) != dwNOBW)) {
                  dwErrCode = ::GetLastError();
                  bRes = FALSE;
               } else {
                  bRes = TRUE;
               }
            }
            if (bRes) {
               if (!::WriteFile(hFile, pResource, dwSize, &dwNOBW, NULL) || (dwSize != dwNOBW)) {
                  dwErrCode = ::GetLastError();
                  bRes = FALSE;
               } else {
                  bRes &= TRUE;
               }
            }
            ::CloseHandle(hFile); hFile = NULL;
         }
      }
   }
   if (pdwErrCode) {
      *pdwErrCode = dwErrCode;
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL String2GUID(IN LPCTSTR szGUID, OUT GUID &guid) {
   BOOL bRes = FALSE;
   DWORD dwErrCode = ERROR_INVALID_PARAMETER;
   if (szGUID) {
      USES_CONVERSION;
      HRESULT hRes = ::CLSIDFromString(T2OLE(const_cast<TCHAR*>(szGUID)), &guid);
      switch (hRes) {
      case NOERROR           : bRes = TRUE ; dwErrCode = ERROR_SUCCESS;    break;
      case CO_E_CLASSSTRING  : bRes = FALSE; dwErrCode = ERROR_BAD_FORMAT; break; // The class string was improperly formatted.
      case REGDB_E_WRITEREGDB: // The CLSID corresponding to the class string was not found in the registry.
      default:
         if (szGUID) {
            dwErrCode = ERROR_INVALID_DATA;
            //    GUID
            // 0         1         2         3
            // 01234567890123456789012345678901234567
            // {01234567-0123-0123-0123-0123456789AB}
            CString strGUID(szGUID);
            strGUID.MakeUpper();
            static TCHAR szABC[] = _T("0123456789ABCDEF");
            if ((strGUID.GetLength() != 38) ||
                (szGUID[ 0] != _T('{')) ||
                (szGUID[ 9] != _T('-')) ||
                (szGUID[14] != _T('-')) ||
                (szGUID[19] != _T('-')) ||
                (szGUID[24] != _T('-')) ||
                (szGUID[37] != _T('}')) /**/||
                (!strGUID.Mid( 1, 8).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(10, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(15, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(20, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(25,12).SpanExcluding(szABC).IsEmpty())/**/
               )
            {
            } else {
               strGUID.Replace(_T('{'), _T(' '));
               strGUID.Replace(_T('-'), _T(' '));
               strGUID.Replace(_T('}'), _T(' '));
               /**
               strGUID = strGUID.Mid( 1, 8) + //
                         strGUID.Mid(10, 4) + // + _T(" ")
                         strGUID.Mid(15, 4) + // + _T(" ")
                         strGUID.Mid(20, 2) + // + _T(" ")
                         strGUID.Mid(22, 2) + // + _T(" ")
                         strGUID.Mid(25, 2) + // + _T(" ")
                         strGUID.Mid(27, 2) + // + _T(" ")
                         strGUID.Mid(29, 2) + // + _T(" ")
                         strGUID.Mid(31, 2) + // + _T(" ")
                         strGUID.Mid(33, 2) + // + _T(" ")
                         strGUID.Mid(35, 2);  // + _T(" ")
               /**/
               int iData1=0, iData2=0, iData3=0, iData4[8] = {0,0,0,0,0,0,0,0};
               if (::_stscanf((LPCTSTR)strGUID, _T("%08X%04X%04X%02X%02X%02X%02X%02X%02X%02X%02X"),
                              &iData1, &iData2, &iData3,
                              &iData4[0], &iData4[1], &iData4[2], &iData4[3],
                              &iData4[4], &iData4[5], &iData4[6], &iData4[7]) == 11)
               {
                  guid.Data1 = iData1; guid.Data2 = iData2; guid.Data3 = iData3;
                  guid.Data4[0] = iData4[0];
                  guid.Data4[1] = iData4[1];
                  guid.Data4[2] = iData4[2];
                  guid.Data4[3] = iData4[3];
                  guid.Data4[4] = iData4[4];
                  guid.Data4[5] = iData4[5];
                  guid.Data4[6] = iData4[6];
                  guid.Data4[7] = iData4[7];
                  bRes = TRUE;
                  dwErrCode = ERROR_SUCCESS;
               } else {
                  dwErrCode = ERROR_INVALID_DATA; //::GetLastError();
               }
            }
         }
      } // swicth
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

CString ErrorCode2Str(DWORD dwErrCode) {
   CString strRes;
   LPTSTR lpMsgBuf = NULL;
   DWORD dwRes = ::FormatMessage(
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
      NULL,
      dwErrCode,
      MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
      (LPTSTR)&lpMsgBuf,
      0,
      NULL
   );
   if (dwRes != 0) {
      strRes = lpMsgBuf;
      strRes.Replace(_T("\r\n"), _T(" "));
      strRes.TrimRight();
   } else {
      //DWORD dwErrCode2 = ::GetLastError(); // must be ERROR_MR_MID_NOT_FOUND ???
   }
   ::LocalFree(lpMsgBuf);
   if (strRes.IsEmpty()) {
      if (dwErrCode & 0x80000000) {
         strRes.Format(_T("0x%08X"), dwErrCode);
      } else {
         strRes.Format(_T("%i"), dwErrCode);
      }
   }
   return strRes;
}

CString ErrorCode2Str(IN HMODULE hModule, IN DWORD dwErrCode) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   LPTSTR szError = NULL;
   DWORD dwBaseLength = ::FormatMessage(
      FORMAT_MESSAGE_IGNORE_INSERTS |
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_HMODULE, // dwFlags
      hModule,                                                      // lpSource
      dwErrCode,                                                    // dwMessageId
      0,                                                            // dwLanguageId
      (LPTSTR)&szError,                                             // lpBuffer
      0,                                                            // nSize
      NULL );                                                       // * arguments

   CString strRes;
   if (dwBaseLength == 0) {
      dwErrCodeRes = ::GetLastError();
   } else {
      strRes = szError;
      strRes.Replace(_T("\r\n"), _T(" "));
      strRes.TrimRight();
   }
   if (szError) {
      ::LocalFree(szError);
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString ErrorCode2Str(IN LPCTSTR lpModuleName, IN DWORD dwErrCode) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   HMODULE hMod = ::GetModuleHandle(lpModuleName);
   BOOL bLoadLibrary = TRUE;
   if (hMod == NULL) {
      hMod = ::LoadLibrary(lpModuleName);
      bLoadLibrary = (hMod != NULL);
      if (!bLoadLibrary) {
         dwErrCodeRes = ::GetLastError();
      }
   }

   CString strRes;
   if (hMod) {
      strRes = ErrorCode2Str(hMod, dwErrCode);
      if (strRes.IsEmpty()) {
         dwErrCodeRes = ::GetLastError();
      }
   }

   if (bLoadLibrary) {
      BOOL bRes = ::FreeLibrary(hMod);
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString WinInetErrorCode2Str(DWORD dwErrCode) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   CString strRes = ErrorCode2Str(_T("WinInet.dll"), dwErrCode);
   if (strRes.IsEmpty()) {
      dwErrCodeRes = ::GetLastError();
   } else {
      strRes = _T("Internet API error. ") + strRes;

      if (dwErrCode == ERROR_INTERNET_EXTENDED_ERROR) {
         DWORD dwInetError = 0;
         DWORD dwExtLength = 0;
         BOOL bRes = nsWinInet_API::InternetGetLastResponseInfo(&dwInetError, NULL, &dwExtLength);
         DWORD dwErrCode2 = ::GetLastError();
         if ((dwErrCode2 != ERROR_INSUFFICIENT_BUFFER) || (dwExtLength==0)) {
            dwErrCodeRes = ::GetLastError();
         } else {
            TCHAR *szExtErrMsg = new TCHAR [dwExtLength = dwExtLength+1]; // + EOL
            if (szExtErrMsg == NULL) {
               dwErrCodeRes = ERROR_OUTOFMEMORY;
            } else {
               szExtErrMsg[0] = 0;
               BOOL bRes = nsWinInet_API::InternetGetLastResponseInfo(&dwInetError, szExtErrMsg, &dwExtLength);
               if (!bRes) {
                  dwErrCodeRes = ::GetLastError();
               } else {
                  strRes += szExtErrMsg;
               }

               delete [] szExtErrMsg;
            }
         }
      }
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

BOOL EnumFiles(IN LPCTSTR szDirName, IN LPCTSTR szMask, IN FILEENUMPROC lpEnumFunc, IN LPVOID lpParam) {
   if (!szDirName || !szDirName[0] || /*!szMask || !szMask[0] || */!lpEnumFunc) return FALSE;
   WIN32_FIND_DATA findFileData;
   HANDLE hFindFile = NULL;
   BOOL bRes = TRUE;
   DWORD dwErrCode = NO_ERROR;
   CString strDirName(szDirName);
   if (strDirName[strDirName.GetLength()-1] != _T('\\')) {
      strDirName += _T('\\');
   }
   do {
      if (hFindFile == NULL) {
         hFindFile = ::FindFirstFile(strDirName + szMask, &findFileData);
         bRes = (hFindFile != INVALID_HANDLE_VALUE);
      } else {
         bRes = ::FindNextFile(hFindFile, &findFileData);
      }
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (hFindFile == INVALID_HANDLE_VALUE) {
            if ((dwErrCode == ERROR_FILE_NOT_FOUND) ||
                (dwErrCode == ERROR_PATH_NOT_FOUND))
            {
               bRes = TRUE;
            }
         } else {
            if (dwErrCode == ERROR_NO_MORE_FILES) {
               bRes = TRUE;
            }
         }
         break;
      } else {
         if (!(findFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
            bRes &= lpEnumFunc(szDirName, findFileData.cFileName, lpParam);
         }
      }
   } while(bRes);
   if (hFindFile != INVALID_HANDLE_VALUE) {
      bRes = ::FindClose(hFindFile); hFindFile = NULL;
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (dwErrCode == ERROR_NO_MORE_FILES) {
            bRes = TRUE;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL EnumSubDir(IN LPCTSTR szDirName, IN DIRENUMPROC lpEnumFunc, IN LPVOID lpParam) {
   if (!szDirName || !szDirName[0] || !lpEnumFunc) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }
   WIN32_FIND_DATA findFileData;
   HANDLE hFindFile = NULL;
   BOOL bRes = TRUE;
   DWORD dwErrCode = NO_ERROR;
   CString strDirName(szDirName);
   if (strDirName[strDirName.GetLength()-1] != _T('\\')) {
      strDirName += _T('\\');
   }
   do {
      if (hFindFile == NULL) {
#if(_WIN32_WINNT >= 0x0400)
         hFindFile = ::FindFirstFileEx(strDirName + _T('*'), FindExInfoStandard, &findFileData, FindExSearchLimitToDirectories, NULL, 0);
         if (hFindFile == INVALID_HANDLE_VALUE)
#endif // (_WIN32_WINNT >= 0x0400)
         {
            hFindFile = ::FindFirstFile(strDirName + _T('*'), &findFileData);
         }
         bRes = (hFindFile != INVALID_HANDLE_VALUE);
      } else {
         bRes = ::FindNextFile(hFindFile, &findFileData);
      }
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (hFindFile == INVALID_HANDLE_VALUE) {
            if ((dwErrCode == ERROR_FILE_NOT_FOUND) ||
                (dwErrCode == ERROR_PATH_NOT_FOUND))
            {
               bRes = TRUE;
            }
         } else {
            if (dwErrCode == ERROR_NO_MORE_FILES) {
               bRes = TRUE;
            }
         }
         break;
      } else {
         if (findFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
            if (findFileData.cFileName[0]==_T('.') && (findFileData.cFileName[1]==_T('\0') ||
                                                      (findFileData.cFileName[1]==_T('.') && findFileData.cFileName[2]==_T('\0'))))
            {} else
            //if (lstrcmp(findFileData.cFileName, _T(".")) &&
            //    lstrcmp(findFileData.cFileName, _T("..")))
            {
               bRes &= lpEnumFunc(szDirName, findFileData.cFileName, lpParam);
            }
            
         }
      }
   } while(bRes);
   if (hFindFile != INVALID_HANDLE_VALUE) {
      bRes = ::FindClose(hFindFile); hFindFile = NULL;
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (dwErrCode == ERROR_NO_MORE_FILES) {
            bRes = TRUE;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

//    C++
void TestCpp(
   int       *      pK0, //               
   int       *const pK1, //    
   int const *      pK2, //               
   int const *const pK3, //    

   int       *      *      ppL0, //                             
   int       *      *const ppL1, //                  
   int       *const *      ppL2, //                  
   int       *const *const ppL3, //       
   int const *      *      ppL4, //                             
   int const *      *const ppL5, //                  
   int const *const *      ppL6, //                  
   int const *const *const ppL7  //       
)
{
   pK0 = new int; // Ok
  *pK0 = 1;       // Ok

// pK1 = new int; // Error
  *pK1 = 1;       // Ok

   pK2 = new int; // Ok
//*pK2 = 1;       // Error

// pK3 = new int; // Error
//*pK3 = 1;       // Error

    ppL0 = new int*; // Ok
   *ppL0 = new int;  // Ok
  **ppL0 = 1;        // Ok

//  ppL1 = new int*; // Error
   *ppL1 = new int;  // Ok
  **ppL1 = 1;        // Ok

    ppL2 = new int*; // Ok
// *ppL2 = new int;  // Error
  **ppL2 = 1;        // Ok

//  ppL3 = new int*; // Error
// *ppL3 = new int;  // Error
  **ppL3 = 1;        // Ok

    ppL4 = (const int **)new int*; // Ok
   *ppL4 = new int;                // Ok
//**ppL4 = 1;                      // Error

//  ppL5 = (const int **)new int*; // Error
   *ppL5 = new int;                // Ok
//**ppL5 = 1;                      // Error

    ppL6 = (const int **)new int*; // Ok
// *ppL6 = new int;                // Error
//**ppL6 = 1;                      // Error

//  ppL7 = (const int **)new int*; // Error
// *ppL7 = new int;                // Error
//**ppL7 = 1;                      // Error
}

/*
//   
int delete_directory(CString dir_path)
{
// 
    CString ext_dir_path;

    //  
    char* sPath;
    sPath = dir_path.GetBuffer(dir_path.GetLength());

    // 
    HANDLE hFind;
    WIN32_FIND_DATA FindFileData;

    TCHAR DirPath[MAX_PATH];
    TCHAR FileName[MAX_PATH];

    _tcscpy(DirPath,sPath);
    _tcscat(DirPath,"\\*");    //   
    _tcscpy(FileName,sPath);
    _tcscat(FileName,"\\");

    hFind = FindFirstFile(DirPath,&FindFileData); //  
    if(hFind == INVALID_HANDLE_VALUE) return FALSE;
    _tcscpy(DirPath,FileName);

    bool bSearch = true;
    while(bSearch) { //  
        if(FindNextFile(hFind, &FindFileData)) {
            if(!(_tcscmp(FindFileData.cFileName, ".") && _tcscmp(FindFileData.cFileName, ".."))){
                continue;}
            _tcscat(FileName,FindFileData.cFileName);
            if((FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
                //  
                ext_dir_path.Append(FileName);
                if(!delete_directory(1, ext_dir_path)) {
                    FindClose(hFind);
                    return FALSE; //  
                }
                RemoveDirectory(FileName); //  
                _tcscpy(FileName, DirPath);
            }
            else {
                if(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_READONLY)
                    SetFileAttributes(FileName, FILE_ATTRIBUTE_NORMAL); //  - 
                if(!DeleteFile(FileName)) {  // 
                    FindClose(hFind);
                    return FALSE;
                }
                _tcscpy(FileName, DirPath);
            }
        }
        else {
            if(GetLastError() == ERROR_NO_MORE_FILES) //  
            bSearch = false;
            else {
                //   
                FindClose(hFind);
                return FALSE;
            }

        }
    }
    FindClose(hFind);  //   
    return RemoveDirectory(sPath); //    
}*/
