////////////////////////////////////////////////////////////////////////////////
// File name: CommonLib.h
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.chat.ru/CommonLib.html
// Date: 2006 03 09
//
// Description:   .
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__KSERG_COMMON_LIB__
#define __FILE__KSERG_COMMON_LIB__

#if _MSC_VER > 1000
   #pragma once
#endif // _MSC_VER > 1000

#ifndef __AFX_H__
   #include <Windows.h>
   #include "CStringKS.h"
#endif
#include <WindowsX.h>
#include <ShlObj.h>
#include <CommDlg.h>
#include <time.h>
#include <process.h>    // _beginthread, _endthread

#define chDIMOF(Array) (sizeof(Array) / sizeof(Array[0])) //    

#ifndef MAKELONGLONG
   #define MAKELONGLONG(dwLow, dwHigh)  ((LONGLONG(DWORD(dwLow)) & 0x00000000FFFFFFFF) | ((LONGLONG(DWORD(dwHigh)) & 0x00000000FFFFFFFF) << 32))
#endif

typedef unsigned (__stdcall *PTHREAD_START) (void *); //   
#define chBEGINTHREADEX(psa, cbStack, pfnStartAddr,   /*   */ \
   pvParam, fdwCreate, pdwThreadId)                 \
      ((HANDLE)_beginthreadex(                      \
         (void *)        (psa),                     \
         (unsigned)      (cbStack),                 \
         (PTHREAD_START) (pfnStartAddr),            \
         (void *)        (pvParam),                 \
         (unsigned)      (fdwCreate),               \
         (unsigned *)    (pdwThreadId)))

__forceinline BOOL RegClass(
    UINT      style,
    WNDPROC   lpfnWndProc,
    int       cbClsExtra,
    int       cbWndExtra,
    HINSTANCE hInstance,
    HICON     hIcon,
    HCURSOR   hCursor,
    HBRUSH    hbrBackground,
    LPCTSTR   lpszMenuName,
    LPCTSTR   lpszClassName
);

__forceinline BOOL             InitializeCriticalSectionEx(CRITICAL_SECTION &cs, DWORD dwSpinCount = 4000);
__forceinline CRITICAL_SECTION InitializeCriticalSectionEx(DWORD dwSpinCount = 4000);
__forceinline CRITICAL_SECTION InitializeCriticalSection();

void Base64_code  (IN const CHAR* strIn, OUT CString& strOut); // Base 64 
void Base64_decode(IN const CHAR* strIn, OUT CString& strOut); // Base 64 
BOOL Base64_code(
   IN BYTE *pData,     //    - ,   
   IN DWORD dwSize,
   OUT CString &strRes //   -  
);
BOOL Base64_decode(
   IN const CString &strIn, //    -  
   OUT BYTE *pData,         //   -  
   IN OUT DWORD &dwSize
);

struct POINTEX: public POINT {
   POINTEX()                 {x=      y=0   ;}
   POINTEX(const POINT &p)   {x=p. x; y=p. y;}
   POINTEX(const SIZE  &p)   {x=p.cx; y=p.cy;}
   POINTEX(LONG nx, LONG ny) {x=  nx; y=  ny;}
   POINTEX& operator+= (const POINT &a) {x+=a.x; y+=a.y; return *this;}
   POINTEX& operator-= (const POINT &a) {x-=a.x; y-=a.y; return *this;}
   POINTEX& operator*= (LONG val      ) {x*=val; y*=val; return *this;}
   POINTEX& operator/= (LONG val      ) {x/=val; y/=val; return *this;}
   operator SIZE() const {SIZE result =   {x,y}; return result;}
   operator RECT() const {RECT rect = {0,0,x,y}; return rect;}
};

__forceinline POINT operator*  (LONG  val     , const POINT &a) {return POINTEX(a.x*val, a.y*val);}
__forceinline POINT operator*  (const POINT &a, LONG  val     ) {return POINTEX(a.x*val, a.y*val);}
__forceinline POINT operator/  (const POINT &a, LONG  val     ) {return POINTEX(a.x/val, a.y/val);}
__forceinline POINT operator+  (const POINT &a, const POINT &b) {return POINTEX(a.x+b.x, a.y+b.y);}
__forceinline POINT operator-  (const POINT &a, const POINT &b) {return POINTEX(a.x-b.x, a.y-b.y);}
__forceinline bool  operator== (const POINT &a, const POINT &b) {return (a.x==b.x && a.y==b.y);}
__forceinline bool  operator!= (const POINT &a, const POINT &b) {return (a.x!=b.x || a.y!=b.y);}

struct SIZEEX: public SIZE {
   SIZEEX()                 {cx=      cy=0   ;}
   SIZEEX(const SIZE  &p)   {cx=p.cx; cy=p.cy;}
   SIZEEX(const POINT &p)   {cx=p. x; cy=p. y;}
   SIZEEX(const RECT  &p)   {cx=p.right - p.left; cy=p.bottom-p.top;}
   SIZEEX(LONG nX, LONG nY) {cx=nX  ; cy=nY  ;}
   SIZEEX& operator+= (const SIZE &a) {cx+=a.cx; cy+=a.cy; return *this;}
   SIZEEX& operator-= (const SIZE &a) {cx-=a.cx; cy-=a.cy; return *this;}
   SIZEEX& operator*= (LONG val     ) {cx*=val ; cy*=val ; return *this;}
   SIZEEX& operator/= (LONG val     ) {cx/=val ; cy/=val ; return *this;}
   operator POINT() const {POINT result =   {cx,cy}; return result;}
   operator RECT () const {RECT  rect = {0,0,cx,cy}; return rect;}
};

__forceinline SIZE operator*  (LONG  val    , const SIZE &a) {return SIZEEX(a.cx*val , a.cy*val );}
__forceinline SIZE operator*  (const SIZE &a, LONG  val    ) {return SIZEEX(a.cx*val , a.cy*val );}
__forceinline SIZE operator/  (const SIZE &a, LONG  val    ) {return SIZEEX(a.cx/val , a.cy/val );}
__forceinline SIZE operator+  (const SIZE &a, const SIZE &b) {return SIZEEX(a.cx+b.cx, a.cy+b.cy);}
__forceinline SIZE operator-  (const SIZE &a, const SIZE &b) {return SIZEEX(a.cx-b.cx, a.cy-b.cy);}
__forceinline bool operator== (const SIZE &a, const SIZE &b) {return (a.cx==b.cx && a.cy==b.cy);}
__forceinline bool operator!= (const SIZE &a, const SIZE &b) {return (a.cx!=b.cx || a.cy!=b.cy);}

struct COORDEX: public COORD {
   COORDEX()                   {X=     Y=0  ;}
   COORDEX(const COORD& p)     {X=p.X; Y=p.Y;}
   COORDEX(SHORT nX, SHORT nY) {X= nX; Y= nY;}
   COORDEX& operator+= (const COORD &a) {X+=a.X; Y+=a.Y; return *this;}
   COORDEX& operator-= (const COORD &a) {X-=a.X; Y-=a.Y; return *this;}
   COORDEX& operator*= (SHORT val     ) {X*=val; Y*=val; return *this;}
   COORDEX& operator/= (SHORT val     ) {X/=val; Y/=val; return *this;}
};

__forceinline COORD operator*  (SHORT val     , const COORD &a) {return COORDEX(a.X*val, a.Y*val);}
__forceinline COORD operator*  (const COORD &a, SHORT val     ) {return COORDEX(a.X*val, a.Y*val);}
__forceinline COORD operator/  (const COORD &a, SHORT val     ) {return COORDEX(a.X/val, a.Y/val);}
__forceinline COORD operator+  (const COORD &a, const COORD &b) {return COORDEX(a.X+b.X, a.Y+b.Y);}
__forceinline COORD operator-  (const COORD &a, const COORD &b) {return COORDEX(a.X-b.X, a.Y-b.Y);}
__forceinline bool  operator== (const COORD &a, const COORD &b) {return (a.X==b.X && a.Y==b.Y);}
__forceinline bool  operator!= (const COORD &a, const COORD &b) {return (a.X!=b.X || a.Y!=b.Y);}

struct RECTEX: public RECT {
    //    X / Y (   )
   RECTEX& moveX(LONG x)         {left += x; right += x; return *this;}
   RECTEX& moveY(LONG y)         {top  += y; bottom+= y; return *this;}
   RECTEX& move (LONG x, LONG y) {moveX(x); return moveY(y);}
   RECTEX& move (const SIZE  &p) {return move(p.cx, p.cy);}

   //   (   )
   RECTEX& alignLeft  (LONG l)         {right  += l-left  ; left   = l; return *this;} //          
   RECTEX& alignRight (LONG r)         {left   += r-right ; right  = r; return *this;} //         
   RECTEX& alignTop   (LONG t)         {bottom += t-top   ; top    = t; return *this;} //        
   RECTEX& alignBottom(LONG b)         {top    += b-bottom; bottom = b; return *this;} //         
   RECTEX& alignLT    (LONG x, LONG y) {alignLeft (x); return alignTop   (y);}
   RECTEX& alignRT    (LONG x, LONG y) {alignRight(x); return alignTop   (y);}
   RECTEX& alignLB    (LONG x, LONG y) {alignLeft (x); return alignBottom(y);}
   RECTEX& alignRB    (LONG x, LONG y) {alignRight(x); return alignBottom(y);}
   RECTEX& alignLT    (const POINT &p) {return alignLT(p.x, p.y);}
   RECTEX& alignRT    (const POINT &p) {return alignRT(p.x, p.y);}
   RECTEX& alignLB    (const POINT &p) {return alignLB(p.x, p.y);}
   RECTEX& alignRB    (const POINT &p) {return alignRB(p.x, p.y);}

   RECTEX& alignCenter(const POINT &c) {return move(SIZEEX(c-center()));}        //       
   RECTEX& alignCenter(const RECT  &r) {return alignCenter(RECTEX(r).center());} //       
   RECTEX& alignCenter(LONG x, LONG y) {return alignCenter(POINTEX(x,y));}       //      

   // get/set metods
   LONG    width () const {return right -left;}
   LONG    height() const {return bottom-top ;}
   RECTEX& width (LONG w) {right  = left+w; return *this;}
   RECTEX& height(LONG h) {bottom = top +h; return *this;}

   POINTEX pointLT() const           {return POINTEX(left , top   );}
   POINTEX pointRT() const           {return POINTEX(right, top   );}
   POINTEX pointLB() const           {return POINTEX(left , bottom);}
   POINTEX pointRB() const           {return POINTEX(right, bottom);}
   RECTEX& pointLT(LONG x, LONG y)   {left  = x; top    = y; return *this;}
   RECTEX& pointRT(LONG x, LONG y)   {right = x; top    = y; return *this;}
   RECTEX& pointLB(LONG x, LONG y)   {left  = x; bottom = y; return *this;}
   RECTEX& pointRB(LONG x, LONG y)   {right = x; bottom = y; return *this;}
   RECTEX& pointLT(const POINT& pLT) {return pointLT(pLT.x, pLT.y);}
   RECTEX& pointRT(const POINT& pRT) {return pointRT(pRT.x, pRT.y);}
   RECTEX& pointLB(const POINT& pLB) {return pointLB(pLB.x, pLB.y);}
   RECTEX& pointRB(const POINT& pRB) {return pointRB(pRB.x, pRB.y);}

   POINTEX center()const          {return POINTEX(left+width()/2, top+height()/2);}
   RECTEX& center( const POINT&c) {return alignCenter( c );} //       
   RECTEX& center( const RECT &r) {return alignCenter( r );} //       
   RECTEX& center(LONG x, LONG y) {return alignCenter(x,y);} //      
   SIZEEX  size  ()const          {return SIZEEX(width(), height());}
   RECTEX& size  ( const SIZE &s) {width(s.cx); return height(s.cy);}

   operator SIZE  () {return size();}
   operator SIZEEX() {return size();}

   // constructors
   RECTEX(const POINT &pLT, const POINT pRB) {left=pLT.x  ; top=pLT.y ; right=pRB.x   ; bottom=pRB.y   ;}
   RECTEX(const RECT &r)                     {left=r.left ; top=r.top ; right=r.right ; bottom=r.bottom;}
   RECTEX(LONG l, LONG t, LONG r, LONG b)    {left=l      ; top=t     ; right=r       ; bottom=b       ;}
   RECTEX(const SIZE &size)                  {left=         top=0     ; right=size.cx ; bottom=size.cy ;}
   RECTEX(LONG width, LONG height)           {left=         top=0     ; right=width   ; bottom=height  ;}
   RECTEX()                                  {left=         top=        right=          bottom=0       ;}
};

__forceinline bool operator== (const RECT &a, const RECT &b) {return (a.left==b.left && a.top==b.top && a.right==b.right && a.bottom==b.bottom);}
__forceinline bool operator!= (const RECT &a, const RECT &b) {return (a.left!=b.left || a.top!=b.top || a.right!=b.right || a.bottom!=b.bottom);}

__forceinline RECTEX FindInnerRect (const SIZE  &sizeInner, const SIZE &sizeOutward);
__forceinline RECTEX FindInnerRect (const RECT  &rectInner, const RECT &rectOutward);
__forceinline BOOL   PointInRect   (const POINT &point, const RECT &rect   ); //   ?
__forceinline BOOL   IntersectRect (const RECT  &rect1, const RECT &rect2  ); //   ?
__forceinline bool   PointInPolygon(const POINT &point, const POINT *const polygon, int size); //   

__forceinline BOOL MoveWindow(HWND, const RECT &rect, BOOL bRepaint = TRUE);
__forceinline BOOL SetWindowPos(HWND hWnd, HWND hWndInsertAfter, const RECT &rect, UINT uFlags);

__forceinline RECTEX  ScreenToClient(HWND, const RECT&);
__forceinline RECTEX  ClientToScreen(HWND, const RECT&);
__forceinline POINTEX ClientToScreen(HWND, const POINT&);
__forceinline POINTEX ScreenToClient(HWND, const POINT&);

__forceinline RECTEX GetWindowRect(HWND hWnd);
__forceinline SIZEEX GetWindowSize(HWND hWnd);
__forceinline RECTEX GetClientRect(HWND hWnd);
__forceinline SIZEEX GetClientSize(HWND hWnd);

__forceinline POINTEX GetCursorPos();
__forceinline void ShowCursor();
__forceinline void HideCursor();

__forceinline CString GetClassName     (HWND);
__forceinline WNDPROC GetWindowProc    (HWND);
__forceinline WNDPROC SetWindowProc    (HWND, WNDPROC pWndProc);
            //DWORD GetWindowStyle   (HWND); //   'WindowsX.h'
__forceinline DWORD   SetWindowStyle   (HWND, DWORD lStyle);
__forceinline DWORD   GetWindowStyleEx (HWND); //   GetWindowExStyle  'WindowsX.h'
__forceinline DWORD   SetWindowStyleEx (HWND, DWORD lStyleEx);
__forceinline LONG    GetWindowUserData(HWND);
__forceinline LONG    SetWindowUserData(HWND, LONG lUserData);

__forceinline BOOL SetMenuText(HMENU hMenu, UINT uItem, BOOL bByPosition, LPCTSTR szNewText);

__forceinline SIZEEX GetScreenSize();

CString SelectFile(BOOL bOpenDialog, HWND hWndOwner, LPCTSTR szDefSelectedFile = NULL, LPCTSTR szDefExt = NULL, LPCTSTR szFilter = _T("All files (*.*)\0*.*\0\0"), LPCTSTR szTitle = NULL, LPCTSTR szInitialDir = NULL, DWORD dwFlags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_PATHMUSTEXIST);
CString SelectFolder(
   HWND hwndOwner  = NULL,                   //    
   LPCTSTR szTitle = _T("Open folder"),      //   
   DWORD dwFlags   = BIF_BROWSEFORCOMPUTER | BIF_DONTGOBELOWDOMAIN | BIF_EDITBOX,
   int nFolder     = /** /CSIDL_DRIVES/**/-1/**/); //  -1 -      
                                             //   - see CSIDL_... (func SHGetSpecialFolderLocation)


              LONGLONG GetFileSizeEx (LPCTSTR szFileName); //  
              DWORD    GetFileSize   (LPCTSTR szFileName); //  
__forceinline CString  GetFileDir    (LPCTSTR szPathAlongWithFileName); //         (     )
__forceinline CString  GetFileName   (LPCTSTR szPathAlongWithFileName); //      
              CString  GetFileVersion(LPCTSTR szFilename);
__forceinline BOOL PathExist(LPCTSTR szPath);
__forceinline BOOL FileExist(LPCTSTR szPath);
__forceinline CString  GetMenuString(HMENU hMenu, UINT uIDItem, UINT uFlag);
__forceinline CString  GetModuleFileName(HMODULE hModule = NULL); // retrieves the full path and filename for the executable file containing the specified module
__forceinline CString  GetModuleDir     (HMODULE hModule); //        (    )

CString GetWindowText(HWND hWnd);

__forceinline CString GetComputerName();
__forceinline CString GetUserName();

__forceinline CString GetCurrentDirectory();
__forceinline CString GetSystemDirectory();
__forceinline CString GetWindowsDirectory();
__forceinline CString GetTempPath();

__forceinline SIZEEX SizeIcon(HICON hIcon);
__forceinline SIZEEX SizeBitmap(HWND hWnd, BOOL bClientRect = FALSE); //    
__forceinline SIZEEX SizeBitmap(HDC hCDC); // only for compatible device context
__forceinline SIZEEX SizeBitmap(HBITMAP hBmp); // hBmp       

__forceinline HBITMAP CreateBitmap(int iWidth, int iHeight);  // create compatible bitmap at desktop
__forceinline HBITMAP CreateBitmap(const SIZE &size);         // create compatible bitmap at desktop
__forceinline HBITMAP CreateMask(const SIZE &sizeBmp);        // create monohrome bitmap
              HBITMAP CreateMask(HBITMAP hBmp, COLORREF transparentColor = CLR_INVALID); // create monohrome bitmap from color bitmap

__forceinline int rand(int maxDiapason); //     0  maxDiapason,   

CString MemCopyAsString(LPCVOID pData, size_t iSize, TCHAR chSeparatorEOL = _T('\n'));
CString MemCopyAsHex   (LPCVOID pData, size_t iSize, BOOL bUsePrefix = FALSE, LPCTSTR szSeparator = NULL);

void BeepSpeaker(DWORD dwFreq = 500, DWORD dwDuration = 0x25);

__forceinline CString Format(LPCTSTR szFormat, ...);
#ifndef _UNICODE
   __forceinline CString AnsiToOem(LPCTSTR);
   __forceinline CString OemToAnsi(LPCTSTR);
#endif // _UNICODE
__forceinline CString Replace(IN const CString &str, IN LPCTSTR szOld, IN LPCTSTR szNew);
__forceinline CString Replace(IN const CString &str, IN TCHAR    cOld, IN TCHAR    cNew);

class COSVersion {
private:
   OSVERSIONINFO m_vi;
public:
   COSVersion() {
      m_vi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
      BOOL bRes = ::GetVersionEx(&m_vi);
      if (!bRes) memset(&m_vi,0,sizeof(OSVERSIONINFO));
   }
   bool IsWinXP()       const {return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_NT) && (m_vi.dwMajorVersion == 5) && (m_vi.dwMinorVersion == 1));}
   bool IsWin2000()     const {return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_NT) && (m_vi.dwMajorVersion == 5) && (m_vi.dwMinorVersion == 0));}
   bool IsWinNT()       const {return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_NT) && ((m_vi.dwMajorVersion == 4) || (m_vi.dwMajorVersion == 3))/* && (m_vi.dwMinorVersion == 0)*/);}
   bool IsWin9598Me()   const {return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) && (m_vi.dwMajorVersion == 4)/* && (m_vi.dwMinorVersion == 0)*/);}
};

__forceinline SYSTEMTIME GetSystemTime();
__forceinline SYSTEMTIME GetLocalTime();
__forceinline FILETIME   GetSystemTimeAsFileTime();
__forceinline SYSTEMTIME FileTimeToSystemTime(const FILETIME   &FileTime);
__forceinline FILETIME   SystemTimeToFileTime(const SYSTEMTIME &SysTime);
__forceinline FILETIME   FileTimeToLocalFileTime(const FILETIME &FileTime);

__forceinline BOOL BitBlt    (HDC, const RECT&, HDC, const SIZE&, DWORD);
__forceinline BOOL BitBlt    (HDC, const RECT&, HDC, /* ={0,0} */ DWORD);
__forceinline BOOL BitBlt    (HDC, const SIZE&, HDC, const SIZE&, DWORD);
__forceinline BOOL BitBlt    (HDC, const SIZE&, HDC, /* ={0,0} */ DWORD);
__forceinline BOOL StretchBlt(HDC, const RECT&, HDC, const RECT&, DWORD);
__forceinline BOOL StretchBlt(HDC, const RECT&, HDC, const SIZE&, DWORD);
__forceinline BOOL StretchBlt(HDC, const SIZE&, HDC, const SIZE&, DWORD);

class CRegistry {
public:
   // Agreement:
   //
   // HKEY_CURRENT_USER\SOFTWARE\szParam = "string"
   // HKEY_CURRENT_USER\SOFTWARE\dwParam = 0x000123
   //                                      |______|-- Value or Data
   // |_________________________|-------------------- Key
   //                            |______|------------ Name or ValueName
   // |_________________________________|------------ KeyName
   //

   // read methods
   static CString GetString(IN HKEY hKey, IN LPCTSTR szName                    , OUT PDWORD pdwErrCode = NULL); // Return value
   static DWORD   GetDWord (IN HKEY hKey, IN LPCTSTR szName                    , OUT PDWORD pdwErrCode = NULL); // Return value
   static DWORD   GetBinary(IN HKEY hKey, IN LPCTSTR szName, OUT BYTE  *pbValue, IN OUT DWORD &dwSizeValue);    // Return error code!!!
   // write methods
   static DWORD   SetString(IN HKEY hKey, IN LPCTSTR szName, IN LPCTSTR szValue);                               // Return error code
   static DWORD   SetDWord (IN HKEY hKey, IN LPCTSTR szName, IN DWORD   dwValue);                               // Return error code
   static DWORD   SetBinary(IN HKEY hKey, IN LPCTSTR szName, IN const BYTE *pbValue, IN DWORD dwSizeValue);     // Return error code

   // read methods
   static CString GetString(IN LPCTSTR szKeyName                               , OUT PDWORD pdwErrCode = NULL); // Return value.         Example - "HKEY_CURRENT_USER\\SOFTWARE\\strParam"
   static DWORD   GetDWord (IN LPCTSTR szKeyName                               , OUT PDWORD pdwErrCode = NULL); // Return value.         Example - "HKEY_CURRENT_USER\\SOFTWARE\\dwParam"
   static DWORD   GetBinary(IN LPCTSTR szKeyName, OUT BYTE  *pbValue, IN OUT DWORD &dwSizeValue);               // Return error code!!!. Example - "HKEY_CURRENT_USER\\SOFTWARE\\bnParam", you byte array for result, size byte array.
   // write methods
   static DWORD   SetString(IN LPCTSTR szKeyName, IN LPCTSTR szValue);                           // Return error code. Example - "HKEY_CURRENT_USER\\SOFTWARE\\strParam", "value"
   static DWORD   SetDWord (IN LPCTSTR szKeyName, IN DWORD   dwValue);                           // Return error code. Example - "HKEY_CURRENT_USER\\SOFTWARE\\dwParam", 123
   static DWORD   SetBinary(IN LPCTSTR szKeyName, IN const BYTE *pbValue, IN DWORD dwSizeValue); // Return error code. Example - "HKEY_CURRENT_USER\\SOFTWARE\\bnParam", you byte array, size byte array.

   // find methods
   static CString EnumSubKeyName(IN HKEY     hKey    , IN int iIndex                   , OUT PDWORD pdwErrCode = NULL);
   static CString EnumSubKeyName(IN LPCTSTR szKeyName, IN int iIndex                   , OUT PDWORD pdwErrCode = NULL); // example - "HKEY_CURRENT_USER\\SOFTWARE", 1  or  "HKEY_CURRENT_USER\\SOFTWARE\\", 1
   static CString EnumValueName (IN HKEY     hKey    , IN int iIndex, OUT DWORD &dwType, OUT PDWORD pdwErrCode = NULL);
   static CString EnumValueName (IN LPCTSTR szKeyName, IN int iIndex, OUT DWORD &dwType, OUT PDWORD pdwErrCode = NULL); // example - "HKEY_CURRENT_USER\\SOFTWARE", 1  or  "HKEY_CURRENT_USER\\SOFTWARE\\", 1
};

__forceinline CString MIMEType2FileType(LPCTSTR szMIMEType);
__forceinline CString FileType2MIMEType(LPCTSTR szFileType);

CString GetIPAdress();
CString GetHostName();

LPVOID GetResource( //     
   IN HINSTANCE hInstance,
   IN LPCTSTR szResourceName,
   IN LPCTSTR szResourceType,
   OUT DWORD &dwSize,
   OUT PDWORD pdwErrCode = NULL
);
BOOL SaveResourceAsFile( //              bReplaceFile == TRUE
   IN HINSTANCE hInstance,
   IN LPCTSTR szFileName,
   IN LPCTSTR szResourceName,
   IN LPCTSTR szResourceType,
   IN BOOL    bReplaceFile,
   OUT PDWORD pdwErrCode = NULL
);

__forceinline CString GUID2String(IN REFGUID guid);
              BOOL    String2GUID(IN LPCTSTR szGUID, OUT GUID &guid); // example - {00000000-0000-0000-C000-000000000046} to IID_IUnknown
__forceinline GUID    String2GUID(IN LPCTSTR szGUID); //    {FFFFFFFF-FFFF-FFFF-FFFF-FFFFFFFFFFFF}
__forceinline GUID    CoCreateGuid();

CString ErrorCode2Str(DWORD dwErrCode = ::GetLastError());
CString ErrorCode2Str(IN HMODULE hModule, IN DWORD dwErrCode);
CString ErrorCode2Str(IN LPCTSTR lpModuleName, IN DWORD dwErrCode);
CString WinInetErrorCode2Str(DWORD dwErrCode); // from WinInet.dll

typedef BOOL (CALLBACK* FILEENUMPROC)(IN LPCTSTR szDirName, IN LPCTSTR szFileName  , IN LPVOID lpParam); // if return FALSE -> stop enumerators
typedef BOOL (CALLBACK* DIRENUMPROC )(IN LPCTSTR szDirName, IN LPCTSTR szSubDirName, IN LPVOID lpParam); // if return FALSE -> stop enumerators
BOOL EnumFiles (IN LPCTSTR szDirName, IN LPCTSTR szMask, IN FILEENUMPROC lpEnumFunc, IN LPVOID lpParam); //  
BOOL EnumSubDir(IN LPCTSTR szDirName,                    IN  DIRENUMPROC lpEnumFunc, IN LPVOID lpParam); //  

__forceinline CString Language(WORD wIDLanguage, LCTYPE LCType = LOCALE_SLANGUAGE);

#include "CommonLib.hpp"

#endif // __FILE__KSERG_COMMON_LIB__
